# See https://pre-commit.com for more information
# See https://pre-commit.com/hooks.html for more hooks
---
# Use exclude to exclude specific files
# exclude: '^fixtures/'
repos:
  - repo: https://github.com/pre-commit/pre-commit-hooks
    rev: v5.0.0{# datasource=github-tags depName=pre-commit/pre-commit-hooks #}  # renovate:managed
    hooks:
      - id: trailing-whitespace
      - id: end-of-file-fixer
      - id: check-yaml
      - id: check-case-conflict
      - id: check-symlinks
      - id: check-json
      - id: detect-private-key
      - id: mixed-line-ending
        args: ["--fix=lf"]
      - id: no-commit-to-branch
        args: [--branch, main]
      - id: pretty-format-json
        args: [--autofix, --no-sort-keys]

  # pre-commit tasks from common-ci-tasks
  # Documentation available at
  # https://gitlab.com/gitlab-com/gl-infra/common-ci-tasks/-/blob/main/docs/pre-commit.md
  - repo: https://gitlab.com/gitlab-com/gl-infra/common-ci-tasks
    rev: v2.62  # renovate:managed

    hooks:
      - id: shellcheck  # Run shellcheck for changed Shell files
      - id: shfmt  # Run shellcheck for changed Shell files
      - id: update-asdf-version-variables  # Update .gitlab-ci-asdf-versions.yml if .tool-versions has changed

      # - id: gitlint  # Checks your git commit messages for style
      - id: gitleaks  #  Detect hardcoded secrets using Gitleaks
      - id: editorconfig  # Validate text files against .editorconfig
      - id: yamllint  # Validate YAML files using yamllint
{% if golang %}
      - id: go-fmt  # Run gofmt for changed Go files
      - id: go-imports  # Run go-imports for changed Go files
      - id: go-mod-tidy  # Run go mod tidy for changed Go files
      - id: go-test  # Run go test for the project if any go files have changed
      - id: golangci-lint  # Run golangci-lint for changed Go files
{% endif %}{% if terraform %}
      - id: terraform-fmt  # Apply terraform fmt across all changed terraform files
      - id: terraform-tflint  # Run tflint on changed modules
      - id: terra-transformer-validate-roots  # Run terra-transformer validate on root modules
{% endif %}{% if jsonnet %}
      - id: jsonnet-fmt  # Apply jsonnetfmt across all changed jsonnet files
{% endif %}
